#ifndef _GlobalVariables_h
#define _GlobalVariables_h 1

#include "../include/Externals.h"   // define structures (Joerg Sep05)

prm Params;        // CCM parameter
ctrl Control;      // program Control Parameters
UC UnitCell;       // defines the unit cell completely
sub sublatticeMagnetisation;  // defines the subLattice
neighbours LatticeNeighbours;
bravais BravaisLattice;
symmetries LatticeSymmetries;
spinConfigs spinConfigurations[MAX_NUM_CONFIGURATIONS];
spinConfigs connectedConfigurations[MAX_NUM_CONFIGURATIONS];
spinConfigs latticeAnimals[MAX_NUM_CONFIGURATIONS];
int         NumberConfigurations;
int         NumberLatticeAnimals;

double CCMcoeffs[MAX_NUM_CONFIGURATIONS]={0.0};

hamiltonian_defn Hamiltonian_types[MAX_BONDS+1][MAX_TERMS_t];
hamiltonian_defn Hamiltonian      [MAX_BONDS+1][MAX_TERMS_h];

// Other global variables.

int  max_number_cells_BT;
int lookUpTable[MAX_BT+1][5];
int BTarray[MAX_LSUBM][MAX_LSUBM][MAX_LSUBM];

// removed (not used, Joerg05)
// double x_array[2];
// double y_array[2];
// double z_array[2];
// int    x_index[2];
// int    y_index[2];
// int    z_index[2];
// int    cell_index[2];
int    totalPoints;

/* obtain */

int binary_max[31];
int trimary_max[MAX_LSUBM+1];
int quartary_max[MAX_LSUBM+1];

// file pointers.

FILE *fp;
FILE *fp_gs;
FILE *fp1;
FILE *fp2;

// solve variables.

double maximum;
double minimum;
double increment;
double *delta=NULL; /* Parameter array of size Params.bonds d1*H1+d2*H2+... */

// restriction on choice of clusters.

int restrictionClusters;

// direction bonds or not?

int directional;

// restriction of sweeping for F_k F_m s_k^z s_m^z terms.

int midPointX;
int midPointY;
int midPointZ;
int radius;

// solution strategy

int solutionStrategy;

// parallel variables

int myid;
int npe;
#endif
